#
#        Tokyoflash-Uhr On Air
#        ---------------------
#          Uwe Berger; 2012
#
# http://www.tokyoflash.com/de/watches/kisai/on_air_black/
#

# Groesse/Farbe Window
set gvar(wx) 400
set gvar(wy) $gvar(wx)
set gvar(bg_color) black

# Groesse einer Einheit
set gvar(dx) [expr $gvar(wx) / 2 / 32]
set gvar(dy) [expr $gvar(dx) / 1.4]

# Linienstaerke
set gvar(line_width) [expr $gvar(dy) / 1.7]

# Hintergrundfarbe
set gvar(clock_bg_color) darkblue

# Linienfarbe
set gvar(line_color) white

# interne Variable
set gvar(old_m) 60

# Digit-Definition 0...9
# Linienelement jeweils x0 y0 x1 y1
set digit [list\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 3 1 3} {0 4 1 4}\
			{1 0 9 0} {1 4 9 4}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 3 1 3} {0 4 1 4}\
		}\
		{\
			{0 0 1 0} {0 2 1 2} {0 3 1 3} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 2 1 2} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2}\
			{1 2 9 2}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 3 1 3} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0}\
			{1 0 9 0}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 3 1 3} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{0 0 1 0} {0 1 1 1} {0 2 1 2} {0 4 1 4}\
			{1 0 9 0} {1 2 9 2} {1 4 9 4}\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
		{\
			{9 0 10 0} {9 1 10 1} {9 2 10 2} {9 3 10 3} {9 4 10 4}\
		}\
				
	]
	
# Winkel von 03 Uhr gesehen
#                0   1   2   3 4  5  6  7   8   9   10  11 
set angles [list -90 -60 -30 0 30 60 90 120 150 180 210 240]

	
#***************************
proc gui {} {
	global gvar
	# Fenster generieren
	wm title . "Tokyoflash On Air" 
	wm resizable . 0 0
	canvas	.clock -width $gvar(wx) -height $gvar(wy) -bg $gvar(bg_color) -bd 0
	pack .clock 
	.clock create oval 0 0 $gvar(wx) $gvar(wy) -fill $gvar(clock_bg_color) -outline $gvar(clock_bg_color)
}	

#***************************
proc draw_digit {val d} {
	global gvar digit
	# die Zahl wird an die "Grundstellung" ( 03 Uhr) gezeichnet
	.clock delete d$d
	set offset_x [expr $gvar(wx)/2 + $d * ($gvar(wx)/2)/3]
	set offset_y [expr $gvar(wy)/2]
	# die 1 sieht an der Zehnerstelle sieht (lt. Produktvideo) 
	# anders aus. Entsprechendes Abbild dazu in digit-Liste
	# an Index 10
	if {($val == 1) && ($d == 1)} {
		set val 10	
	}
	# einzelne Striche zeichnen...
	foreach line [lindex $digit $val] {
		foreach {x0 y0 x1 y1} $line {
			set x0 [expr ($x0 * $gvar(dx)) + $offset_x]
			set y0 [expr (($y0 - 2) * $gvar(dy)) + $offset_y]
			set x1 [expr ($x1 * $gvar(dx)) + $offset_x - ($gvar(line_width) * 1.5)]
			set y1 [expr (($y1 - 2) * $gvar(dy)) + $offset_y]
			.clock create line 	$x0\
								$y0\
								$x1\
								$y1\
								-width $gvar(line_width)\
								-fill $gvar(line_color)\
								-capstyle round\
								-tags d$d
		}
	}
}

#***************************
# http://wiki.tcl.tk/8595
#***************************
 proc object_rotate {w tag Ox Oy angle} {
    set angle [expr {$angle * atan(1) / 45.0}]
    set sin [expr {sin($angle)}]
    set cos [expr {cos($angle)}]
    foreach id [$w find withtag $tag] {
        set xy {}
        foreach {x y} [$w coords $id] {
            set x [expr {$x - $Ox}]
            set y [expr {$y - $Oy}]
            set xx [expr {$x * $cos - $y * $sin + $Ox}]
            set yy [expr {$x * $sin + $y * $cos + $Oy}]
            lappend xy $xx $yy
        }
        $w coords $id $xy
    }
 }

#***************************
proc takt {} {
	global gvar angles
	# Uhrzeit ermitteln
	set m [scan [clock format [clock seconds] -format %M] %d]
	set h [scan [clock format [clock seconds] -format %H] %d]
	# hat sich etwas an der Zeit geaendert
	if {$gvar(old_m) != $m} {
		set gvar(old_m) $m
		# 12-Stunden-Darstellung
		if {$h > 11} {
			set h [expr $h - 12]	
		}
		# Minute-Zehner/-Einer zeichnen
		draw_digit [expr $m/10] 1
		draw_digit [expr $m%10] 2
		# und entsprechend hindrehen...
		if {$h > 6} {
			object_rotate .clock d1 [expr $gvar(wx)/2 + $gvar(wx)/2/3 + 10*$gvar(dx)] [expr $gvar(wy)/2] 180
			object_rotate .clock d2 [expr $gvar(wx)/2 + $gvar(wx)/2/3 + 10*$gvar(dx)] [expr $gvar(wy)/2] 180
		}
		object_rotate .clock d1 [expr $gvar(wx)/2] [expr $gvar(wy)/2] [lindex $angles $h]
		object_rotate .clock d2 [expr $gvar(wx)/2] [expr $gvar(wy)/2] [lindex $angles $h]
	}
	# Prozedur nach 1 Sekunde neu aufrufen	
	after 1000 takt
}
 
#***************************
#***************************
#***************************
gui
takt
